%define major		18
%define libname		%mklibname %name %major
%define libnamedev	%mklibname %name -d
%define build_opensync	1

Name: 	 	barry
Summary: 	Linux interface to RIM BlackBerry devices
Summary(de):	Linuxinterface zu RIMs BlackBerry Geräten
Version: 	0.18.4
Release: 	%mkrel 2
Source0:	%name-%version.tar.xz
Source1:	barryicon.png
Patch:		99-blackberry-perms.rules.patch
URL:		http://www.netdirect.ca/software/packages/barry/
License:	LGPL/GPLv2+
Group:		Communications
BuildRoot:	%{_tmppath}/%{name}-buildroot
BuildRequires:	ImageMagick libtar-devel %{_lib}sm-devel %{_lib}usb1.0-devel %{_lib}SDL-devel
BuildRequires:	boost-devel %{_lib}fuse-devel gettext-devel doxygen autoconf zlib-devel
BuildRequires:	gtkmm2.4-devel gettext-devel %{_lib}xml++2.6-devel %{_lib}glademm2.4-devel
%if %build_opensync
BuildRequires:	libopensync-devel
%endif

%description
Barry is a GPL C++ library for interfacing with the RIM BlackBerry Handheld.

It comes with a command line tool for exploring the device and a GUI for
making quick backups and udev rules which allow the device to be charged
via a USB port.

%description -l de
Barry ist eine GPL-C + +-Bibliothek für das Arbeiten mit dem RIM BlackBerry Handheld.

Es kommt mit einem Kommandozeilen-Tool für die Erkundung der Einrichtung und einer GUI für
die Erstellung schneller Backups und udev-Regeln, sodass das Gerät am USB-Port geladen werden kann.


%package -n 	%{libname}
Summary:	BlackBerry(tm) Desktop for Linux - libbarry libraries
Summary(de):	BlackBerry(tm) Desktop für Linux - %{_lib}barry Bibliotheken
Group:          System/Libraries
Requires:	libusb 
Requires:	boost
Obsoletes: 	%{libname} < %{version}-%{release}
Conflicts:	%{name}-tools < %{version}-%{release}
Conflicts:	%{name}-charge < %{version}-%{release}
Conflicts:	%{name}-opensync < %{version}-%{release}
Conflicts:	%{name}-gui < %{version}-%{release}
Conflicts:	%{name}-ppp < %{version}-%{release}

%description -n %{libname}
Barry is a desktop toolset for managing your BlackBerry(tm) device. (BlackBerry
is a registered trademark of Research in Motion Limited.)

This package contains the library files, license agreement, README file,
and most other assorted documentation common to all sub-packages. You most
likely want to also install barry-util and barry-gui.

%description -n %{libname} -l de
Barry ist ein Desktop-Toolset für die Verwaltung Ihres BlackBerry (TM)-Geräts. 
(BlackBerry ist ein eingetragenes Warenzeichen von Research In Motion Limited.)

Dieses Paket enthält die Bibliotheksdateien, Lizenzvereinbarung, README-Datei,
und die meisten anderen sortierten Unterlagen, die für alle Sub-Pakete. Wahrscheinlich können 
wollen Sie auch barry-util und barry-gui installieren.

%package -n 	%{libnamedev}
Summary: 	BlackBerry(tm) Desktop for Linux - libbarry libraries
Summary(de):	BlackBerry(tm) Desktop für Linux - %{_lib}barry Bibliotheken
Group: 		Development/Libraries
Requires: 	libusb-devel 
Requires:	boost-devel
Requires: 	%{libname} >= %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release} 
Obsoletes: 	%{name}-devel

%description -n %{libnamedev}
Barry is a desktop toolset for managing your BlackBerry(tm) device. (BlackBerry
is a registered trademark of Research in Motion Limited.)

This package contains the development library files for Barry, libbarry.

%description -n %{libnamedev} -l de
Barry ist ein Desktop-Toolset für die Verwaltung Ihrer BlackBerry (TM)-Gerät. (BlackBerry
ist ein eingetragenes Warenzeichen von Research In Motion Limited.)

Dieses Paket enthält die Entwicklungs-Bibliothek-Dateien für Barry, libbarry.

%package tools
Summary:	BlackBerry(tm) Tools
Group:		Communications
Requires: 	%{libname} >= %{version}-%{release}
Obsoletes: 	%{name}-tools < %{version}-%{release}

%description tools
Barry is a desktop toolset for managing your BlackBerry(tm) device. (BlackBerry
is a registered trademark of Research in Motion Limited.)

This package contains the commandline tools btool, breset and others.

%description tools -l de
Barry ist ein Desktop-Toolset für die Verwaltung Ihrer BlackBerry (TM)-Gerät. (BlackBerry
ist ein eingetragenes Warenzeichen von Research In Motion Limited.)

Dieses Paket enthält die Kommandozeilenprogramme btool, breset und weitere.

%package charge
Summary:	BlackBerry(tm) Charging Scripts
Summary(de):	BlackBerry(tm) Skripte zum Laden des Akkus
Group:		Communications
Obsoletes: 	%{name}-charge < %{version}-%{release}

%description charge
Barry is a desktop toolset for managing your BlackBerry(tm) device. (BlackBerry
is a registered trademark of Research in Motion Limited.)

This package installs special handshake and udev scripts which allow
a BlackBerry device to be charged via USB at 500mA.

%description charge -l de
Barry ist ein Desktop-Toolset für die Verwaltung Ihrer BlackBerry (TM)-Gerät. (BlackBerry
ist ein eingetragenes Warenzeichen von Research In Motion Limited.)

Dieses Paket installiert spezielle Handshake- und udev-Skripte, die es erlauben
ein BlackBerry Gerät an einem USB-Port bei 500mA zu laden.

%package gui
Summary:	BlackBerry(tm) Backup Tool
Summary(de):	BlackBerry(tm) Backupprogramm
Group:		Communications
Requires: 	%{libname} >= %{version}-%{release}
Obsoletes: 	%{name}-gui < %{version}-%{release}

%description gui
Barry is a desktop toolset for managing your BlackBerry(tm) device. (BlackBerry
is a registered trademark of Research in Motion Limited.)

This package contains a graphical applications to backup and restore data
from a BlackBerry device.

%description gui -l de
Barry ist ein Desktop-Toolset für die Verwaltung Ihrer BlackBerry (TM)-Gerät. (BlackBerry
ist ein eingetragenes Warenzeichen von Research In Motion Limited.)

Dieses Paket enthält eine Programm mit grafischer Oberfläche um Daten von einem
BlackBerry Gerät zu sichern oder wiederherzustellen.

%if %build_opensync
%package opensync
Summary:	BlackBerry(tm) opensync plugin
Summary(de):	BlackBerry(tm) opensync Plugin
Group:		Communications
Requires: 	%{libname} >= %{version}-%{release}
Obsoletes: 	%{name}-opensync < %{version}-%{release}

%description opensync
Barry is a desktop toolset for managing your BlackBerry(tm) device. (BlackBerry
is a registered trademark of Research in Motion Limited.)

This package contains the opensync plugin to synchronize a BlackBerry with
other devices and applications.

%description opensync -l de
Barry ist ein Desktop-Toolset für die Verwaltung Ihrer BlackBerry (TM)-Gerät. (BlackBerry
ist ein eingetragenes Warenzeichen von Research In Motion Limited.)

Dieses Paket enthält das opensync Plugin zum Synchronisieren vom BlackBerry mit
anderen Geräten oder Programmen.

%endif

%package ppp
Summary:	BlackBerry(tm) PPP support utility and example scripts
Summary(de):	BlackBerry(tm) PPP Unterstützung und Beispielskripte
Group:		Communications
Requires: 	ppp
Requires: 	%{libname} >= %{version}-%{release}
Obsoletes:      %{name}-ppp < %{version}-%{release}

%description ppp
Barry is a desktop toolset for managing your BlackBerry(tm) device. (BlackBerry
is a registered trademark of Research in Motion Limited.)

This package contains a utility which enables the use of BlackBerry
devices as cellular data modems, and also contains example PPP scripts
for this purpose.

%description ppp -l de
Barry ist ein Desktop-Toolset für die Verwaltung Ihrer BlackBerry (TM)-Gerät. (BlackBerry
ist ein eingetragenes Warenzeichen von Research In Motion Limited.)

Dieses Paket enthält ein Werkzeug, welches die Nutzung des BlackBerry Geräts
als Cellular Data Modem erlaubt, weiterhin sind Beispiel-PPP-Skripte für diese
Nutzung enthalten.

%prep
%setup -q 
%{__rm} -rf ./doc/www/*.php
%{__rm} -rf ./doc/www/*.sh
%apply_patches

%build
%{configure} --enable-boost --with-zlib --disable-rpath
sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool
%{__make} %{?_smp_mflags}

# gui tree
cd gui/
%{configure} --disable-rpath PKG_CONFIG_PATH="..:$PKG_CONFIG_PATH" CXXFLAGS="-I../.." LDFLAGS="-L../../src"
#--disable-rpath doesn't seem effective
sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool
%{__make} %{?_smp_mflags}
cd ../

# opensync tree
cd opensync-plugin/
%{configure} --disable-rpath PKG_CONFIG_PATH="..:$PKG_CONFIG_PATH" CXXFLAGS="-I../.." LDFLAGS="-L../../src"
#--disable-rpath doesn't seem effective
sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool
%{__make} %{?_smp_mflags}
cd ../

										
%install
rm -rf %{buildroot}
%makeinstall_std

mkdir -p %{buildroot}%{_sysconfdir}/udev/rules.d
cp udev/*.rules %{buildroot}%{_sysconfdir}/udev/rules.d/

mkdir -p %{buildroot}%{_sysconfdir}/security/console.perms.d
cp udev/99-blackberry-perms.rules %{buildroot}%{_sysconfdir}/security/console.perms.d/

mkdir -p %{buildroot}%{_sysconfdir}/modprobe.d/
cp modprobe/blacklist-berry_charge.conf %{buildroot}%{_sysconfdir}/modprobe.d/

mkdir -p %{buildroot}%{_sysconfdir}/ppp/peers
mkdir -p %{buildroot}%{_sysconfdir}/chatscripts

pushd ppp
for f in barry*
do
   if [[ ${f#*.} == "chat" ]]
   then
      install -m 0644 $f %{buildroot}/etc/chatscripts/
   else
      install -m 0644 $f %{buildroot}/etc/ppp/peers/
   fi
done
popd

# Install hal fdi config
%{__mkdir_p} %{buildroot}%{_datadir}/hal/fdi/information/10freedesktop
%{__mkdir_p} %{buildroot}%{_datadir}/hal/fdi/policy/10osvendor
%{__cp} hal/fdi/information/10freedesktop/10-blackberry.fdi %{buildroot}%{_datadir}/hal/fdi/information/10freedesktop

# Install hal support script
%{__mkdir_p} %{buildroot}%{_bindir}
%{__cp} hal/hal-blackberry %{buildroot}%{_bindir}

# opensync tree
cd opensync-plugin/
%{__make} DESTDIR=%{buildroot} install
cd ../

%{__rm} -rf %{buildroot}%{_libdir}/opensync/plugins/*.la
%{__rm} -rf %{buildroot}%{_libdir}/*.la
%{__rm} -rf %{buildroot}%{_libdir}/*.a

cd gui/
%makeinstall_std
cd ../

# menu
mkdir -p %{buildroot}%{_datadir}/applications
cat > %{buildroot}%{_datadir}/applications/%{name}.desktop << EOF
[Desktop Entry]
Name=Barry Backup
Comment=Backup for BlackBerry devices
Comment=Backupprogramm für BlackBerry Geräte
Exec=%{_bindir}/%{name}backup
Icon=%{name}
Terminal=false
Type=Application
StartupNotify=true
Categories=GTK;Utility;Office;PDA;X-MandrivaLinux-Office-Communications-PDA
EOF

mkdir -p %{buildroot}/%{_iconsdir}/hicolor/{16x16,32x32,48x48,64x64,128x128}/apps
convert -scale 16 %{SOURCE1} %{buildroot}/%{_iconsdir}/hicolor/16x16/apps/%{name}.png
convert -scale 32 %{SOURCE1} %{buildroot}/%{_iconsdir}/hicolor/32x32/apps/%{name}.png
convert -scale 48 %{SOURCE1} %{buildroot}/%{_iconsdir}/hicolor/48x48/apps/%{name}.png
convert -scale 64 %{SOURCE1} %{buildroot}/%{_iconsdir}/hicolor/64x64/apps/%{name}.png
install -m 0644 %{SOURCE1} %{buildroot}/%{_iconsdir}/hicolor/128x128/apps/%{name}.png

%clean
rm -rf %{buildroot}

%post
%{update_icon_cache hicolor}
		
%postun
%{clean_icon_cache hicolor}

%files -n %{libname}
%defattr(-,root,root)
%{_libdir}/*.so.%{major}*

%files -n %{libnamedev}
%defattr(-,root,root)
%{_includedir}/*
%{_libdir}/*.so
%{_libdir}/pkgconfig/*.pc

%files tools
%doc AUTHORS ChangeLog NEWS README
%{_sbindir}/breset
%{_bindir}/bdptest
%{_bindir}/bio
%{_bindir}/btool
%{_bindir}/brecsum
%{_bindir}/upldif
#%{_bindir}/bktrans
#%{_bindir}/btranslate
%{_bindir}/bidentify
%{_bindir}/bjavaloader
%{_bindir}/bjdwp
%{_bindir}/bjvmdebug
%{_bindir}/brawchannel
#%{_bindir}/brimtrans
%{_bindir}/bs11nread
%{_bindir}/btardump
%{_datadir}/locale/*/LC_MESSAGES/barry.mo
%{_mandir}/man1/balxparse*
%{_mandir}/man1/bio*
%{_mandir}/man1/bjdwp*
%{_mandir}/man1/brawchannel*
%{_mandir}/man1/btardump*
%{_mandir}/man1/btool*
%{_mandir}/man1/bidentify*
%{_mandir}/man1/bs11nread*
%{_mandir}/man1/brecsum*
%{_mandir}/man1/breset*
%{_mandir}/man1/upldif*

%{_mandir}/man1/bjavaloader*

%{_bindir}/balxparse
%{_bindir}/btarcmp
%{_bindir}/bwatch
%{_bindir}/hal-blackberry

%{_datadir}/hal/fdi/information/10freedesktop/10-blackberry.fdi

%{_mandir}/man1/btarcmp.1.bz2
%{_mandir}/man1/bwatch.1.bz2
   
%files charge
%{_sbindir}/bcharge
%{_sysconfdir}/udev/rules.d/*
%{_sysconfdir}/security/console.perms.d/*
%{_sysconfdir}/modprobe.d/*
%{_mandir}/man1/bcharge*

%files gui
%doc gui/AUTHORS gui/ChangeLog gui/README gui/NEWS gui/TODO
%{_bindir}/barrybackup
%{_datadir}/barry/glade/*.glade
%{_datadir}/applications/*
%{_datadir}/locale/*/LC_MESSAGES/barry-backup.mo
%{_mandir}/man1/barrybackup*
%{_iconsdir}/*


%if %{build_opensync}
%files opensync
%{_libdir}/opensync/plugins/*
%{_datadir}/opensync/defaults/*
%{_datadir}/locale/es/LC_MESSAGES/barry-opensync-plugin.mo
%{_datadir}/locale/fr/LC_MESSAGES/barry-opensync-plugin.mo
%endif

%files ppp
%doc ppp/README
%{_bindir}/bfuse
%{_sbindir}/pppob
%{_mandir}/man1/pppob*
%{_sysconfdir}/chatscripts/*
%{_sysconfdir}/ppp/peers/barry-*
%{_mandir}/man1/bfuse*


%changelog
* Tue Dec 23 2014 bb <bb> 0.18.4-2pclos2014
- fix udev rule

* Sat Nov 22 2014 pinoc <vogtpet at gmail.com> 0.18.4-1pclos2014
- 0.18.4

* Wed Feb 29 2012 ghostbunny <hmhaase at pclinuxosusers dot de> 0.17.1-1pclos2012
- 0.17.1
- added german summaries and descriptions and comment in desktop file section
- added new bin files in %files section for tools
- added new manual files in %files section for tools
- commented {_bindir}/bfuse does not exist
- added %{_lib} macros but opensync libs are not in 64bit repo
- commented cvs related things code moved into a git repo
- added xz compression
- added BuildRequires:	%{_lib}usb1.0-static-devel, %{_lib}usb-compat0.1-devel
- fixed patch directory moved pushd gui/src to src

* Sun Sep 12 2010 Texstar <texstar at gmail.com> 0.15-2pclos2010
- rebuild libboost

